#!/usr/bin/perl
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2000,2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
#
# $Id: ethernet_info.pm,v 1.2 2002/12/04 15:26:15 philippe Exp $

package backend::ethernet_info;


# Arg0 : interface name (eth0, eth1, ...)
# returns :
#   (string) MAC Address
sub get_interface_info {

    if (0 == scalar (@_)) { return; }
    
    my $interface = shift @_;
    print STDERR "Ethernet_info : retrieving information for $interface \n";
    
    my $info = `/sbin/ifconfig $interface 2>/dev/null`;
    $info =~ s/\s+/ /g; # substitute all tabs and line feeds by spaces
    
    # See if we need to proceed
    if ($info !~ /HWaddr/) { exit (1); } # no mac address, hence no useful info
    
    # parse interface info to extract valuable information
    my %eth_info = ();
    ($eth_info{macaddr} = $info."\n" ) =~ s/.*HWaddr (\S+) .*/$1/;

    return $eth_info{macaddr};

# TODO : retrieve other infos ? (MTU, ...)
}


# Don't forget it's perl...
1;
