#!/usr/bin/perl
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2001 Mandrakesoft
# Author Vincent Saugey <vince@mandrakesoft.com>
#
# $Id: analyse-firewalling-rules.pl,v 1.2 2002/12/04 15:26:16 philippe Exp $
#

# This script detect automatic open port for the configuration donne by the user
if (scalar(@ARGV) < 1)
{
my $usage = "Usage : analyse-firewalling-rules.pl <transaction> [ways]\nwhere ways is one of this : --ext or --int";
exit (1);
}

$transaction_name = shift @ARGV;
$way = shift @ARGV;

my @return = `config-wrapper.pl $transaction_name -g Eth0Known -g Eth1Known -g Eth2Known  -g Eth3Known -g Eth4Known -g Eth0BootProto -g Eth1BootProto -g Eth2BootProto  -g Eth3BootProto -g Eth4BootProto -g InternetInterface`;
my @ethknow = chomp @return[0..4];
my @ethBootProto = chomp @return[5..9];
my $internetinterface = $return[10];
chomp ($internetinterface);

if ($way =~ /--ext/) {
	$config = `config-wrapper.pl $transaction_name -g ${internetinterface}BootProto`;
	print "68 : on ${internetinterface} interface get dhcp configuration" if ($config =~ /dhcp/i);
}
else
{
	$OUT = "<ul>";
	my ($SquidServer, $SquidPort, $dhcpdi, $naatserverport) = `config-wrapper.pl $transaction_name -g SquidServer -g SquidPort -g DHCPServer -g NaatServerPort`;
	chomp ($SquidServer, $SquidPort, $dhcpd, $naatserverport);
	for ($i=0; $i<5; $i++) {
		$OUT = "<li>68 on eth$i : interface get dhcp configuration</li>" if ($ethknow[$i] =~ /true/i and $ethBootProto[$i] =~ /(dhcp|bootp)/i and !($internetinterface =~ /Eth$i/i));
	} 
	$OUT .= "<li>$SquidPort is open because Squid Web Proxy set to manual</li>"  if ($SquidServer =~ /(manual|authenticate)/i);
	$OUT .= "<li>80 as been redirect to $SquidPort because of Squid Web Proxy</li>" if ($SquidServer =~ /(transparent|authenticate)/i); 
	$OUT .= "<li>67 is open  because dhcp server running on firewall</li>" if ($dhcpd =~ /on/);
	$OUT .= "<li>${naatserverport} is open for the naat server</li></ul>";
}

print encrypt($OUT);

#this sub replace many characters by their %XX counterparts
sub encrypt
{
  my $result = shift;
  $result =~ s/%/%25/g; # this one should be the first !!!
  $result =~ s/\t/%09/g;
  $result =~ s/\n/%13/g;
  $result =~ s/\r/%10/g;
#  $result =~ s/\n/%13/g;
  $result =~ s/ /%20/g;
  $result =~ s/!/%21/g;
  $result =~ s/\"/%22/g;
  $result =~ s/\#/%23/g;
  $result =~ s/$/%24/g;
  $result =~ s/&/%26/g;
  $result =~ s/\'/%27/g;
  $result =~ s/\(/%28/g;
  $result =~ s/\)/%29/g;
  $result =~ s/\*/%2A/g;
  $result =~ s/\+/%2B/g;
  $result =~ s/,/%2C/g;
  $result =~ s/-/%2D/g;
  $result =~ s/\./%2E/g;
  $result =~ s!/!%2F!g;

  return $result;
}


