#!/usr/bin/perl -W
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2001 Mandrakesoft
# Author Vincent Saugey <vince@mandrakesoft.com>
# Modify by Sylvain de Tilly
#

# Preconfigured firewalling level
# list of preconfigured var backend bastille firewall
# (TCP_FORWARD_SERVICES, UDP_FORWARD_SERVICES)

# ChangeLog :
# Modify to be used by shorewall's templates...
# So the TCP_FORWARD_SERVICES and UDP_FORWARD_SERVICES disepears.
#
# $Id: change-firewalling-level.pl,v 1.5 2002/12/04 15:26:16 philippe Exp $

use strict;

use Getopt::Long;
use vars qw( $opt_help );

use lib qw(/usr/lib/naat);
use backend::util;


my $Usage =<<"End_of_Usage;";
Usage:	change-firewalling-level.pl [trans_name] <levelname>
   - trans_name : The transaction name
   - levelname  : is one of this level : low,medium,high,full.
 Option :
   --help|-h 	Display this help
End_of_Usage;


# Save level type in "configuration"'s file
my $FirewallLevelVar="FirewallLevelVar";

my $low = "result ACCEPT server net client local protocol tcp port www,result ACCEPT server net client local protocol tcp port https,result ACCEPT server net client local protocol tcp port ftp,result ACCEPT server net client local protocol tcp port sftp,result ACCEPT server net client local protocol tcp port pop-3,result ACCEPT server net client local protocol tcp port imap,result ACCEPT server net client local protocol tcp port nntp,result ACCEPT server net client local protocol tcp port ircd,result ACCEPT server net client local protocol tcp port ssh,result ACCEPT server net client local protocol tcp port telnet,result ACCEPT server net client local protocol tcp port login,result ACCEPT server net client local protocol tcp port ldaps,result ACCEPT server net client local protocol tcp port ldap,result ACCEPT server net client local protocol tcp port 8080,result ACCEPT server net client local protocol tcp port 26000,result ACCEPT server net client local protocol tcp port 27000,result ACCEPT server net client local protocol tcp port 27960,result ACCEPT server net client local protocol tcp port 1200,result ACCEPT server net client local protocol tcp port 25,result ACCEPT server net client local protocol tcp port 10000,result ACCEPT server net client local protocol tcp port 98,server net client local result ACCEPT protocol udp port 111,server net client local result ACCEPT protocol udp port 2049";

my $medium = "result ACCEPT server net client local protocol tcp port www,result ACCEPT server net client local protocol tcp port https,result ACCEPT server net client local protocol tcp port ftp,result ACCEPT server net client local protocol tcp port sftp,result ACCEPT server net client local protocol tcp port pop-3,result ACCEPT server net client local protocol tcp port imap,result ACCEPT server net client local protocol tcp port nntp,result ACCEPT server net client local protocol tcp port ircd,result ACCEPT server net client local protocol tcp port ssh,result ACCEPT server net client local protocol tcp port ldap,result ACCEPT server net client local protocol tcp port ldaps,result ACCEPT server net client local protocol tcp port 8080,result ACCEPT server net client local protocol tcp port 10000,result ACCEPT server net client local protocol tcp port 98";

my $high = "result ACCEPT server net client local protocol tcp port www,result ACCEPT server net client local protocol tcp port https,result ACCEPT server net client local protocol tcp port sftp,result ACCEPT server net client local protocol tcp port nntp,result ACCEPT server net client local protocol tcp port ssh,result ACCEPT server net client local protocol tcp port ldaps,result ACCEPT server net client local protocol tcp port ldap";

# No port open
my $full = "";

my %default_level = ("low" => $low, "medium" => $medium, "high" => $high,
		     "full" => $full);


GetOptions( "help" );

if( $opt_help ) {
  print STDERR $Usage;
  exit( 1 );
}

# get the transaction name
my $transaction_name = shift @ARGV if @ARGV;
my $level_name = shift @ARGV if @ARGV;



if ( $level_name ne "low" && $level_name ne "medium" &&
     $level_name ne "high" && $level_name ne "full" ) {
  print STDERR $Usage;
  exit ( 1 );
}

`config-wrapper.pl $transaction_name --set $FirewallLevelVar $level_name`;
`config-wrapper.pl $transaction_name --listadd FirewallRules $default_level{ $level_name }`;

# EOF






