#!/usr/bin/perl -W
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2000,2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
# Updates by Florin Grad and Philippe Libat
# $Id: check-services.pl,v 1.9 2002/12/04 15:26:16 philippe Exp $
#

# Add a service to run in the current runlevel or bring down services 
# and remove them from the current level (dhcp and dns servers, adsl, and so on...)

# This script is typically used as a main event (after 'pre' but before 'post', where 
# it is executed after templates have been applied and before services are started)


# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if @ARGV;
# If the transaction already exists (i.e this script is executed 
# because of a proxy variable), it will read values in this file.
# If not (i.e. script executed on an event), the get will init 
# it. The file will remain untouched until the same transaction is 
# initialized again (which will overwrite the file).

if (! $transaction_name ) {
    $transaction_name = "$$";
    # initialize a backend transaction
    system ("config-wrapper.pl $transaction_name -i");
}


# DHCP Server 
$ENV{SECURE_LEVEL} ||= 4;
my $dhcp = `config-wrapper.pl $transaction_name -g DHCPServer`;
if ( $dhcp =~ /off/i ) {
    system ("sudo","/sbin/service", "dhcpd", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "dhcpd");
} else {
    system ("sudo","/bin/chmod","a+x","/etc/init.d/dhcpd");
    system ("sudo","/sbin/chkconfig", "--add", "dhcpd");

# The service should be started because of an event
#    system ("sudo","/sbin/service", "dhcpd", "start");
}

# DNS Server 
my $dns = `config-wrapper.pl $transaction_name -g DNSServer`;
if ( $dns =~ /off/i ) {
    system ("sudo","/sbin/service", "named", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "named");
} else {
    system ("sudo","/bin/chmod","a+x","/etc/init.d/named");
    system ("sudo","/sbin/chkconfig", "--add", "named");
# The service should be started because of an event
#    system ("sudo","/sbin/service", "named", "start");
}

# DynDns Server 
my $dyndns = `config-wrapper.pl $transaction_name -g DynDnsService`;
if ( $dyndns =~ /off/i ) {
    system ("sudo","/sbin/service", "ez-ipupdate", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "ez-ipupdate");
} else {
    system ("sudo","/bin/chmod","a+x","/etc/init.d/ez-ipupdate");
    system ("sudo","/sbin/chkconfig", "--add", "ez-ipupdate");
# The service should be started because of an event
#    system ("sudo","/sbin/service", "ez-ipupdate", "start");
}

# Squid Server 
my $squid = `config-wrapper.pl $transaction_name -g SquidServer`;
if ( $squid =~ /off/i ) {
    system ("sudo","/sbin/service", "squid", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "squid");
    system ("sudo","/sbin/service", "dansguardian", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "dansguardian");
} else {
    system ("sudo","/bin/chmod","a+x","/etc/init.d/squid");
    system ("sudo","/sbin/chkconfig", "--add", "squid");
# The service should be started because of an event
#    system ("sudo","/sbin/service", "squid", "start");
}

# dansguardian Server 
my $dansguardian = `config-wrapper.pl $transaction_name -g ContentFilter`;
if ( $dansguardian =~ /off/i ) {
    system ("sudo","/sbin/service", "dansguardian", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "dansguardian");
} else {
    system ("sudo","/bin/chmod","a+x","/etc/init.d/dansguardian");
    system ("sudo","/sbin/chkconfig", "--add", "dansguardian");
# The service should be started because of an event
#    system ("sudo","/sbin/service", "squid", "start");
}

# Filtering Rules (currently shorewall) 
my $filtering = `config-wrapper.pl $transaction_name -g Filtering`;
if ( $filtering =~ /off|stop/i ) {
    system ("sudo","/sbin/service", "shorewall", "stop");
    system ("sudo","/sbin/service", "shorewall", "clear");
    system ("sudo","/sbin/chkconfig", "--del", "shorewall");
} else {
    system ("sudo","/bin/chmod","a+x","/etc/init.d/shorewall");
    system ("sudo","/sbin/chkconfig", "--add", "shorewall");
}

# VPN (frees/wan ipsec)
my $vpn = `config-wrapper.pl $transaction_name -g VPN`;
if ( $vpn =~ /off/i ) {
    system ("sudo","/sbin/service", "ipsec", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "ipsec");
} else {
    system ("sudo","/bin/chmod","a+x","/etc/init.d/ipsec");
    system ("sudo","/sbin/chkconfig", "--add", "ipsec");
}

# Prelude IDS
my $prelude = `config-wrapper.pl $transaction_name -g PreludeState`;
if ( $prelude =~ /off/i ) {
    system ("sudo","/sbin/service", "prelude", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "prelude");
} else {
    system ("sudo","/bin/chmod","a+x","/etc/init.d/prelude");
    system ("sudo","/sbin/chkconfig", "--add", "prelude");
# The service should be started because of an event
#    system ("sudo","/sbin/service", "prelude", "start");
}

# Snort IDS
my $snort = `config-wrapper.pl $transaction_name -g SnortState`;
if ( $snort =~ /off/i ) {
    system ("sudo","/sbin/service", "snortd", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "snortd");
} else {
    system ("sudo","/bin/chmod","a+x","/etc/init.d/snortd");
    system ("sudo","/sbin/chkconfig", "--add", "snortd");
# The service should be started because of an event
#    system ("sudo","/sbin/service", "snortd", "start");
}

# ADSL/PPP/ISDN 
my $internet_type = `config-wrapper.pl $transaction_name -g InternetAccessType`;
my $adsl_type = `config-wrapper.pl $transaction_name -g ADSLType`;
if (( $internet_type =~ /adsl/i ) && ($adsl_type !~ /speedtouch/i)) {
    system ("sudo","/sbin/service", "isdn4linux", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "isdn4linux");
    system ("sudo","/sbin/service", "diald", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "diald");
    system ("sudo","/bin/chmod","a+x","/etc/init.d/adsl");
    system ("sudo","/sbin/chkconfig", "--add", "adsl");
} elsif ($internet_type =~ /ppp/i ) {
    system ("sudo","/sbin/service", "adsl", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "adsl");
    system ("sudo","/sbin/chkconfig", "--add", "diald");
# The service should be started because of an event
#    system ("sudo","/sbin/service", "diald", "start");
} elsif ($internet_type =~ /isdn/i ) {
    system ("sudo","/sbin/service", "adsl", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "adsl");
    system ("sudo","/sbin/chkconfig", "--add", "isdn4linux");
    system ("sudo","/sbin/chkconfig", "--add", "diald");
# The service should be started because of an event
#    system ("sudo","/sbin/service", "diald", "start");
} else {
    system ("sudo","/sbin/service", "diald", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "diald");
    system ("sudo","/sbin/service", "adsl", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "adsl");
    system ("sudo","/sbin/service", "isdn4linux", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "isdn4linux");
}
# Syslog Server 
my $syslog = `config-wrapper.pl $transaction_name -g SYSLOGLocal`;
if ( $syslog =~ /off/i ) {
    system ("sudo","/sbin/service", "syslog", "stop");
    system ("sudo","/sbin/chkconfig", "--del", "syslog");
} else {
    system ("sudo","/sbin/chkconfig", "--add", "syslog");
}

if ( $transaction_name eq "$$" ) {
    # cleanup the transaction
    system ("config-wrapper.pl $transaction_name -a");
}


