#!/usr/bin/perl -w
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2000,2001 Mandrakesoft
# Author Philippe Libat <philippe@mandrakesoft.com>
# 
# $Id: date.pl,v 1.2 2002/12/04 15:26:16 philippe Exp $
#

use strict;
use lib qw(/usr/lib/naat);
use backend::util;
use backend::config;

use strict;

# Usage: date.pl [trans_name] MM/DD/YYYY-hh:mm:ss

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
#my $transaction_name = shift @ARGV if (scalar(@ARGV) == 2);
my $transaction_name = shift @ARGV if (@ARGV);

my $valeur = shift @ARGV;
exit (1) unless defined $valeur;
my ($date, $time) = split (/-/, $valeur);

#
#  date and time format : 'MM/DD/YYYY'  'hh:mm'
#

#my ($date, $time) = split (/ /, $valeur);
if (!$time) { $time = `date +%T`; print "$time\n"; }

if ( ($date =~ /^(\d){1,2}\/(\d){1,2}\/(\d){4}$/) ||
	 ($time =~ /^(\d){1,2}:(\d){1,2}$/ ) ) {
	my %clock_cfg;
	tie %clock_cfg, 'backend::config', '/etc/sysconfig/clock';
	my  $zone;
	$zone = $clock_cfg{'ZONE'};

	#
	# Zone Info
	unlink "/etc/localtime";
	symlink "../usr/share/zoneinfo/$zone", "/etc/localtime";
	
	#
	# Set Date and Time
	my $output = `sudo /bin/date -s '$date $time'`;
	print $output;
	
	#
	# synchronize hardware clock
	system ("sudo","/sbin/hwclock","--systohc","--utc");

} else { 
	print STDERR "Usage: $0 [trans_name] MM/DD/YYYY-hh:mm:ss\n";
	exit 1;
}

exit; 

