#!/usr/bin/perl -w
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2000,2001 Mandrakesoft
# Author Florin Grad <florin@mandrakesoft.com>
# 
# $Id: dns-hosts.pl,v 1.2 2002/12/04 15:26:16 philippe Exp $
#

use strict;
use lib qw(/usr/lib/naat);
use backend::util;

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if ( @ARGV && $ARGV[1] !~ /^-/ );

my $Usage =<<"End_of_Usage;";

Usage:	dns-hosts.pl [trans_name] domain_name < -l | -a name IP | -d name (|IP) >
	dns-hosts.pl [trans_name] domain_name < --list | --add name IP | --delete name (|IP) >

--list|-l	Displays the list of the already defined hostnames

--add|-a	Adds a user in the hosts name lists
		EXAMPLE: dns-hosts.pl design.net -a sunlight 192.168.1.125

--delete|-d	Deletes the line(s) coresponding to the hostname or IPaddress argument
		EXAMPLE: dns-hosts.pl design.net -d sunlight (or 192.168.1.125)

End_of_Usage;

my $chroot = "/var/named";

# arg0 : list | add | delete

# Check if there are at least 2 arguments given
if ( scalar (@ARGV) le 1 ) {
    print STDERR $Usage;
    exit(3);
}

if ( $ARGV[1] eq "--list" || $ARGV[1] eq "-l") {
	backend::util::print_list_dns_hosts_names ($chroot, $ARGV[0]);
} elsif ( $ARGV[1] eq "--add" || $ARGV[1] eq "-a") {
	backend::util::add_dns_hosts_names ($chroot, $ARGV[0], $ARGV[2], $ARGV[3]);
	backend::util::increase_serial ($chroot, $ARGV[0]);
} elsif ( $ARGV[1] eq "--delete" || $ARGV[1] eq "-d") {
	backend::util::delete_dns_hosts_names ($chroot, $ARGV[0], $ARGV[2]);
	backend::util::increase_serial ($chroot, $ARGV[0]);
} else {
print STDERR $Usage;
};

