#!/usr/bin/perl
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2000,2001 Mandrakesoft
# Author David Odin <odin@mandrakesoft.com>
# 
# $Id: download_packages.pl,v 1.5 2002/12/04 15:26:16 philippe Exp $
#
# Modified by: francois Pons <fpons@mandrakesoft.com>
#

# version 0.2
# The purpose of this script is to download the packages given
# on the command line or in the $PackagesList variable.

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if @ARGV;

# if $test = 1, the package list is taken on the command-line
# if $test = 0, the package list is taken from the proxy variable config file
my $test = 0;

# First part, get the config variables...
my ($CurrentMirror, $PackagesList);

if ($test)
{
  $CurrentMirror = $ARGV[0];
  $PackagesList = $ARGV[1];
} else
{
  if (! $transaction_name ) {
	$transaction_name = "$$";
	# initialize a backend transaction
	system ("config-wrapper.pl $transaction_name -i");
  }

  # Get the CurrentMirror value
  $CurrentMirror = `config-wrapper.pl $transaction_name -g CurrentMirror`;
  chomp $CurrentMirror;
  # Get the PackagesList
  $PackagesList = `config-wrapper.pl $transaction_name -g PackagesList`;

  if ( $transaction_name eq "$$" ) {
      # cleanup the transaction
      system ("config-wrapper.pl $transaction_name -a");
  }
}


my ($arch, $rep, @list);

$rep="";

use urpm;
$urpm = new urpm;
$urpm->read_config;
($medium) = grep { $_->{name} eq "Update" } @{$urpm->{media}};
$medium or die "unable to find Update medium\n";
$urpm->parse_synthesis($medium);

my %packages;
chomp $PackagesList;
$urpm->search_packages(\%packages, [ split ",", $PackagesList ]);
$urpm->filter_packages_to_upgrade(\%packages,  sub {
	my ($urpm, $from_id, @choices_id) = @_;
	$choices_id[0];
});

my ($local_sources, $list, $local_to_removes) = $urpm->get_source_packages(\%packages);
unless ($local_sources || $list) {
	die "unable to get source packages, aborting\n";
}
# clean cache (necessary to avoid /var/cache/urpmi explosion).
foreach (@$local_to_removes) {
	unlink $_;
}
my %sources = $urpm->download_source_packages($local_sources, $list, 'force_local', undef);

exit 0;
#################################################################################################
## now get the list of updatable packages
#open F, "curl -s $CurrentMirror/$mandrake_release/ls-lR |";
#foreach (<F>)
#{
#  if (/^([^ ]+):$/)
#  {
#    $rep = "updates/$mandrake_release/$1";
#  } elsif (/^(-|l)/)
#  {
#    $rep =~ /SRPMS/ and next;
#    my @l = split;
#    push @to_update, "$l[8]" if $l[8];
#  }
#}
#close F or die;
#
## Find the architecture and set $rep accordingly
#
#$arch = `uname -m | sed -e s/i.86/i586/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/`;
#chop $arch;
#
#if ($arch =~ /i586/)
#{
#  $rep = "/RPMS";
#} else
#{
#  $rep = "/$arch/RPMS";
#}
#
## now do the download
#$PackagesList =~ s/,/|/g;
#chomp $PackagesList; # beware of '\n' at the end of the last name
#
#print STDERR "Packages to download: $PackagesList \n";
#
#foreach (@to_update)
#{
#  m!(^|/)($PackagesList)-([^-]+)-([^-]+)\.[^.]+\.rpm$! or next;
#
#  print STDERR "Downloading package $_ in directory $rep on $CurrentMirror/$mandrake_release$rep \n";
#
#  `curl -s "$CurrentMirror/$mandrake_release$rep/$_" -o "$download_rep$_";`
#
#}
#
