#!/usr/bin/perl -W
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2000,2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
#
# $Id: ethernet-known-interfaces.pl,v 1.5 2003/11/19 21:46:51 florin Exp $
#

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if @ARGV;

my $with_zones = 0;
$ARGV[ 0 ] && print STDERR "$ARGV[ 0 ]\n";
# Transactions operations
if ( $ARGV[ 0 ] && ( $ARGV[0] eq "--with-zones" || $ARGV[0] eq "-z" ) ) {
  $with_zones = 1;
}

# Look for Known Ethernet Interfaces
my @known_interfaces = ();

if (! $transaction_name ) {
    $transaction_name = "$$";
    # initialize a backend transaction
    system ("config-wrapper.pl $transaction_name -i");
}

# buil the backend request string
my $request = "";
for (my $i=0; $i<5; $i++) {
  $request .= " --get Eth${i}Known";
}

my @known = `config-wrapper.pl $transaction_name $request`;
my $j=0;


if ( $with_zones ) {
  print STDERR "OK\n";
  for (my $i=0; $i<5; $i++) {
    if ( $known[$i] =~ /true/i ) {
      my $zone_name = `config-wrapper.pl $transaction_name --get Eth${j}ZoneName`;
      chop( $zone_name ); # Remove the '\n'
      push (@known_interfaces, "eth" . $i . " $zone_name" );
    }
  }
}
else {
  for (my $i=0; $i<5; $i++) {
    if ( $known[$i] =~ /true/i ) {
      push (@known_interfaces,"eth".$i);
    }
  }
}

print join (',',@known_interfaces)."\n";


if ( $transaction_name eq "$$" ) {
    # cleanup the transaction
    system ("config-wrapper.pl $transaction_name -a");
}
