#!/usr/bin/perl -W
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2001 Mandrakesoft
# Author Vincent Saugey <vince@mandrakesoft.com>
#
# $Id: format-interface-volume.pl,v 1.4 2002/12/04 15:26:16 philippe Exp $
#

if (@ARGV) {
    my $transaction_name = shift @ARGV ; 
}
else {
    print STDERR "Usage : format-interface-volume.pl <transaction_name> <interface>";
    exit 1;
}
my $interface = "";
if (@ARGV) {
    $interface = shift @ARGV if (@ARGV); 
}
else {
    print STDERR "Usage : format-interface-volume.pl <transaction_name> <interface>";
    exit 1;
}

open VOL, "/var/www-naat/html/genfiles/" . $interface . ".vol";
my @volume = <VOL>;
close(VOL);


exit (1) if (scalar(@volume) == 0);

my $table = "<table border=3> <tr> <td> </td> <td>IN </td> <td>OUT </td> </tr>";
my ($in, $out) = split ' ',  shift @volume;
$table .= "<tr> <td>Last hour</td> <td>$in</td> <td>$out</td> </tr>";
($in, $out) = split ' ', shift @volume;
$table .= "<tr> <td>Last 24 hours</td> <td>$in</td> <td>$out</td> </tr>";
($in, $out) = split ' ',  shift @volume;
$table .= "<tr> <td>Last 7 seven days</td> <td>$in</td> <td>$out</td> </tr>";
($in, $out) = split ' ',  shift @volume;
$table .= "<tr> <td>Last month</td> <td>$in</td> <td>$out</td> </tr>";
($in, $out) = split ' ',  shift @volume;
$table .= "<tr> <td>Last year</td> <td>$in</td> <td>$out</td> </tr> </table>";


print encrypt($table);
exit (0);

#this sub replace many characters by their %XX counterparts
sub encrypt
{
  my $result = shift;
  $result =~ s/%/%25/g; # this one should be the first !!!
  $result =~ s/\t/%09/g;
  $result =~ s/\n/%13/g;
  $result =~ s/\r/%10/g;
#  $result =~ s/\n/%13/g;
  $result =~ s/ /%20/g;
  $result =~ s/!/%21/g;
  $result =~ s/\"/%22/g;
  $result =~ s/\#/%23/g;
  $result =~ s/$/%24/g;
  $result =~ s/&/%26/g;
  $result =~ s/\'/%27/g;
  $result =~ s/\(/%28/g;
  $result =~ s/\)/%29/g;
  $result =~ s/\*/%2A/g;
  $result =~ s/\+/%2B/g;
  $result =~ s/,/%2C/g;
  $result =~ s/-/%2D/g;
  $result =~ s/\./%2E/g;
  $result =~ s!/!%2F!g;

  return $result;
}


