#!/usr/bin/perl -W
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 
# $Id: fwlogsummary.pl,v 1.7 2002/12/04 15:26:16 philippe Exp $

# Based on the fwlogsummary.cgi
# This script generates 8 fwlogwatch html summaries in a directory visible
# to your web server.
# The log file to be used can be specified as first parameter, default is
# /var/log/messages
# With respective permissions it can be run as cgi by the webserver.
# You can also invoke this script directly from the command line or from
# cron (you might want to remove the header output).

#RECENT="-l 1h"
my $HREFDIR="/genfiles/modules/fwlogwatch";
my $WEBDIR="/var/www-naat/html$HREFDIR";
my $FWLOGWATCH="/usr/sbin/fwlogwatch";
my $CONFDIR="/etc/fwlogwatch-snf.config";
my $RECENT="-c $CONFDIR -m 2";
my $MESSAGES="-f /var/log/messages";

if ( ! -f $FWLOGWATCH ) {
  print "$FWLOGWATCH not found!";
  exit 1;
}

if ( ! -d $WEBDIR ) { mkdir($WEBDIR) or die "can't create $WEBDIR: $!"; }

# functions


sub write_config
{
	my $output="";
	open CONFIG, ">/etc/fwlogwatch-snf.config" or die "can't open $file: $!";
	$output .= "parser 	= n \n";
	$output .= "textcolor	= FFFFFF\n";
	$output .= "bgcolor	= 	21449C\n";
	$output .= "rowcolor1	= 4B62AB\n";
	$output .= "rowcolor2	= 7683BC\n";
	$output .= "title	= Firewall Logs Summary\n";
	print CONFIG "$output";
	close (CONFIG);
}


sub display_output
{
	my $output=shift;
	open INDEX, ">".$WEBDIR."/index.html" or die "can't open $file: $!";
	print INDEX "$output";
	close (INDEX);
}

sub display_link  {
	my ($href,$label)=@_;
	my $out.="<A onClick='window.open(\"$href\",\"logs\",\"toolbar=yes,menubar=no,scrollbars=yes,width=800,height=480,resizable=yes\"); return false' href=\"$href\">$label</A>";
	return $out;
}


sub encrypt
{
	my $result = shift;
	if ($result) {
		$result =~ s/%/%25/g; # this one should be the first !!!
		$result =~ s/\t/%09/g;
		$result =~ s/\n/%13/g;
		$result =~ s/\r/%10/g;
		$result =~ s/ /%20/g;
		$result =~ s/!/%21/g;
		$result =~ s/\"/%22/g;
		$result =~ s/\#/%23/g;
		$result =~ s/$/%24/g;
		$result =~ s/&/%26/g;
		$result =~ s/\'/%27/g;
		$result =~ s/\(/%28/g;
		$result =~ s/\)/%29/g;
		$result =~ s/\*/%2A/g;
		$result =~ s/\+/%2B/g;
		$result =~ s/,/%2C/g;
		$result =~ s/-/%2D/g;
		$result =~ s/\./%2E/g;
		$result =~ s!/!%2F!g;
	};
	return $result;
}

# Main
# init colors and settings
write_config();

# generate html files
system("$FWLOGWATCH $MESSAGES $RECENT -w -t -z -S                -o $WEBDIR/dst.html");
system("$FWLOGWATCH $MESSAGES $RECENT -w -t -z    -D             -o $WEBDIR/src.html");
system("$FWLOGWATCH $MESSAGES $RECENT -w -t -z                   -o $WEBDIR/src_dst.html");
system("$FWLOGWATCH $MESSAGES $RECENT -w -t -z       -s          -o $WEBDIR/src_dst_sp.html");
system("$FWLOGWATCH $MESSAGES $RECENT -w -t -z          -d       -o $WEBDIR/src_dst_dp.html");
system("$FWLOGWATCH $MESSAGES $RECENT -w -t -z       -s -d       -o $WEBDIR/src_dst_sp_dp.html");
system("$FWLOGWATCH $MESSAGES $RECENT -w -t -z       -s -d -y    -o $WEBDIR/src_dst_sp_dp_op.html");
system("$FWLOGWATCH $MESSAGES $RECENT -w -t -z       -s -d -y -n -o $WEBDIR/all.html");

# generate index.html
$output .= "<font face=\"Arial, Helvetica\">
<div align=\"center\">
<h3>Firewall Logs Summary by criteria:</h3>
</div>
<ul>";

my %label;
$label{src		} = "Source IP address only";
$label{dst		} = "Destination IP address only";
$label{src_dst		} = "Source and destination IP address";
$label{src_dst_sp	} = "With source port";
$label{src_dst_dp	} = "With destination port";
$label{src_dst_sp_dp	} = "With source and destination port";
$label{src_dst_sp_dp_op	} = "With tcp options";
$label{all		} = "Everything and name resolution";

my $i=1;
my $comma=",";
my $output_html="";

foreach ( sort ( keys (%label) ) ) {
	my $key=$_;
	my $value=$label{$_};

$output .= "<li>".display_link ("$HREFDIR/$key.html","$value")."</li>";

$link=encrypt(display_link("$HREFDIR/$key.html","<img title=\"View\" border=\"0\" src=\"images/icn-magnify.png\" alt=\"$key\"/>"));
$value=encrypt($value);

$output_html .= "$link (label=$value)$comma";
$i++;
}

$output .= "</ul>";

chomp $output_html;

if ($output_html =~ /\S+/) { $output_html =~ s/,$//; }
print "$output_html\n" if ($output_html);

# display it index 
display_output ($output);

