#!/bin/sh
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 
# $Id: fwlogsummary.sh,v 1.4 2002/12/04 15:26:16 philippe Exp $

# Based on the fwlogsummary.cgi
# This script generates 8 fwlogwatch html summaries in a directory visible
# to your web server.
# The log file to be used can be specified as first parameter, default is
# /var/log/messages
# With respective permissions it can be run as cgi by the webserver.
# You can also invoke this script directly from the command line or from
# cron (you might want to remove the header output).

#RECENT="-l 1h"
HREFDIR="/secure/modules/fwlogwatch"
WEBDIR="/var/www-naat/html"$HREFDIR
FWLOGWATCH="/usr/sbin/fwlogwatch"
CONFDIR="/etc/fwlogwatch-snf.config"
RECENT="-c $CONFDIR -m 2"

if [ ! -f $FWLOGWATCH ] ; then
  echo "$FWLOGWATCH not found!"
  exit
fi

if [ ! -d $WEBDIR ] ; then
  echo "Directory $WEBDIR does not exist!"
  mkdir -p $WEBDIR
fi

#if [ ! -f $CONFDIR ] ; then
cat <<EOF > /etc/fwlogwatch-snf.config
parser	= n
textcolor	= FFFFFF
bgcolor	= 	21449C
rowcolor1	= 4B62AB
rowcolor2	= 7683BC
title		= Firewall Logs Summary
EOF
#fi

if [ -z $1 ]
then
  MESSAGES="-f /var/log/messages"
else
#  MESSAGES="-f $1"
  MESSAGES="-f /var/log/messages"
fi
# functions
output () {
out=$1
cat <<EOF | tee -a $WEBDIR/index.html
$out
EOF
}

display_link () {
href=$1
label=$2
cat <<EOF
<li><A onClick='window.open("$href","help","toolbar=yes,menubar=no,scrollbars=yes,width=800,height=480,resizable=yes"); return false' href="$href">$label</A></li>
EOF
}

# main
$FWLOGWATCH $MESSAGES $RECENT -w -t -z -S                -o $WEBDIR/dst.html
$FWLOGWATCH $MESSAGES $RECENT -w -t -z    -D             -o $WEBDIR/src.html
$FWLOGWATCH $MESSAGES $RECENT -w -t -z                   -o $WEBDIR/src_dst.html
$FWLOGWATCH $MESSAGES $RECENT -w -t -z       -s          -o $WEBDIR/src_dst_sp.html
$FWLOGWATCH $MESSAGES $RECENT -w -t -z          -d       -o $WEBDIR/src_dst_dp.html
$FWLOGWATCH $MESSAGES $RECENT -w -t -z       -s -d       -o $WEBDIR/src_dst_sp_dp.html
$FWLOGWATCH $MESSAGES $RECENT -w -t -z       -s -d -y    -o $WEBDIR/src_dst_sp_dp_op.html
$FWLOGWATCH $MESSAGES $RECENT -w -t -z       -s -d -y -n -o $WEBDIR/all.html
cat <<EOF | tee $WEBDIR/index.html
<font face="Arial, Helvetica">
<div align="center">
<h3>Firewall Logs Summary by criteria:</h3>
</div>
<ul>
EOF

output "`display_link "$HREFDIR/src.html" 'source IP address only'`"
output "`display_link "$HREFDIR/dst.html" 'destination IP address only'`"
output "<ul>"
output "`display_link "$HREFDIR/src_dst.html" 'source and destination IP address'`"
output "`display_link "$HREFDIR/src_dst_sp.html" 'with source port'`"
output "`display_link "$HREFDIR/src_dst_dp.html" 'with destination port'`"
output "`display_link "$HREFDIR/src_dst_sp_dp.html" 'with source and destination port'`"
output "<ul>"
output "`display_link "$HREFDIR/src_dst_sp_dp_op.html" 'with tcp options'`"
output "</ul>"
output "</ul>"
output "`display_link "$HREFDIR/all.html" 'everything and name resolution'`"
output '</ul>
<br>
</font>
'
