#!/usr/bin/perl -W
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
#
# $Id: ifcfg.pl,v 1.2 2002/12/04 15:26:16 philippe Exp $
#

use File::Basename;

# Stop or Start an ethernet interface based on the name 
# with which this script was launched

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if @ARGV;


for ($0) {

    # keep only the relevant info
    my $name = basename $_;
    
    # split action (start or stop) and interface name
    my ($action,$interface) = split /-/, $name;

#    print "$action $interface \n";

    # analyze action and operate
    $action =~ /start/ and do { 
	[ -e "/etc/sysconfig/network-scripts/ifcfg-$interface" ] &&
	system ("/sbin/ifup",   "$interface" ); 
    };
    $action =~ /stop/  and do { 
	[ -e "/etc/sysconfig/network-scripts/ifcfg-$interface" ] &&
	system ("/sbin/ifdown", "$interface" ); 
    };

}
