#!/usr/bin/perl -W
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
#
# $Id: internet-access.pl,v 1.2 2002/12/04 15:26:16 philippe Exp $
#

# Start or Stop the Internet connection


# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if (@ARGV && $ARGV[0] !~ /^-/);

exit if $ARGV[0] !~ /^-/;

(my $operation = $ARGV[0]) =~ s/^-//;

if (! $transaction_name ) {
    $transaction_name = "$$";
    # initialize a backend transaction
    system ("config-wrapper.pl $transaction_name -i");
}

my $internet_type = `config-wrapper.pl $transaction_name -g InternetAccessType`;
if ( $internet_type =~ /adsl/i ) {
    system ("sudo","/sbin/service", "adsl", $operation);
} 
elsif ( $internet_type =~ /isdn/i ) {
    system ("sudo","/sbin/service", "isdn4linux", $operation);
    system ("sudo","/sbin/service", "diald", $operation);
}
elsif ( $internet_type =~ /ppp/i ) {
    system ("sudo","/sbin/service", "diald", $operation);
}
elsif ( $internet_type =~ /lan/i ) {
    # get the external interface
    my $interface = `config-wrapper.pl $transaction_name -g InternetInterface`;

    # start or stop it
    $operation =~ /start/i and do { 
	[ -e "/etc/sysconfig/network-scripts/ifcfg-$interface" ] &&
	system ("sudo","/sbin/ifup",   "$interface" ); 
    };
    $operation =~ /stop/i  and do { 
	[ -e "/etc/sysconfig/network-scripts/ifcfg-$interface" ] &&
	system ("sudo","/sbin/ifdown", "$interface" ); 
    };
}


if ( $transaction_name eq "$$" ) {
    # cleanup the transaction
    system ("config-wrapper.pl $transaction_name -a");
}


