#!/bin/sh
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 
#
# Script to make action on list 
# add,delete a element 
#
# Usage : list-manage.sh [trans] "LIST" [--add|-a] "element"
# 	  list-manage.sh [trans] "LIST" [--del|-d] "element"

# Usage : list-manage.sh [trans] "LIST" [--add|-a] "element" "attribut" "valeur"
#	  list-manage.sh [trans] "LIST" [--del|-d] "element" "attribut" "valeur"

# samples
#
# Where LIST is formated like this : a,b,c,d
# or  LIST can contain : a (A=10,B=10),b (C=10,D=10),c (E=10,F=10), (F=10,G=10)d
# element to add or delete  may be : a or b or c

# $Id: list-manage.sh,v 1.2 2002/12/04 15:26:16 philippe Exp $

#Functions
Usage ()
{
 echo "Usage $0 [trans_name] \"LIST\" [--add|-a|--del|-d] \"ELEMENT\"" >&2
}

Add ()
{
# 1st : LIST
# 2 : ELEM
L=$1
E=$2
if [ $L == "---" ]; then
  L=""
fi
echo $L,$E |tr ',' '\n'  | sort -buf | tr '\n' ',' | sed -e 's/^,//; s/,$//' | xargs
}

Del ()
{
# 1st : LIST
# 2 : ELEM
L=$1
E=$2
# split list around ","
echo $L |tr ',' '\n' |  awk ' $1 !~ /^'$E'$/ { print } ' | sort -buf | tr '\n' ',' | sed -e 's/^,//; s/,$//' | xargs
} 

Add_Attr ()
{
# 1st : LIST
# 2 : ELEM
L=$1
E=$2
if [ $L == "---" ]; then
  L=""
fi
echo $L,$E |tr ',' '\n'  | sort -buf | tr '\n' ',' | sed -e 's/^,//; s/,$//' | xargs
}

Del_Attr ()
{
# 1st : LIST
# 2 : ELEM
L=$1
E=$2
# split list around ","
echo $L |tr ',' '\n' |  awk ' $1 !~ /^'$E'$/ { print } ' | sort -buf | tr '\n' ',' | sed -e 's/^,//; s/,$//' | xargs
} 
# number of argument
case $# in
	6)
	# here,  6 arguments
        # 1st argument contain Transaction name
	TRANS=$1
        # 2nd argument contain LIST
	LIST=$2
        # 4th argument contain ELEMENT
	ELEM=$4
	ATTR=$5
	VAL=$6
        # 3rd argument contain Action
	TMP_LIST=`config-wrapper.pl $TRANS -g $LIST  2>/dev/null`
        case $3 in
		--add|-a) 
			TMP_LIST=`Add_Attr "$TMP_LIST" "$ELEM"`
			config-wrapper.pl $TRANS -s $LIST $TMP_LIST 2>/dev/null
		 ;;

		--del|-d)
			TMP_LIST=`Del_Attr "$TMP_LIST" "$ELEM"`
			config-wrapper.pl $TRANS -s $LIST $TMP_LIST 2>/dev/null
		 ;;

		*) Usage
		 echo $TMP_LIST  | xargs >&2
		 exit 2 ;;
	esac
#		echo "-------Debug--------"
		RESULT=`config-wrapper.pl $TRANS -g $LIST 2>/dev/null`
		echo $RESULT >&2
	;;


	4)
	# here,  4 arguments
        # 1st argument contain Transaction name
	TRANS=$1
        # 2nd argument contain LIST
	LIST=$2
        # 4th argument contain ELEMENT
	ELEM=$4
        # 3rd argument contain Action
	TMP_LIST=`config-wrapper.pl $TRANS -g $LIST  2>/dev/null`
        case $3 in
		--add|-a) 
			TMP_LIST=`Add "$TMP_LIST" "$ELEM"`
			config-wrapper.pl $TRANS -s $LIST $TMP_LIST 2>/dev/null
		 ;;

		--del|-d)
			TMP_LIST=`Del "$TMP_LIST" "$ELEM"`
			config-wrapper.pl $TRANS -s $LIST $TMP_LIST 2>/dev/null
		 ;;

		*) Usage
		 echo $TMP_LIST  | xargs >&2
		 exit 2 ;;
	esac
#		echo "-------Debug--------"
		RESULT=`config-wrapper.pl $TRANS -g $LIST 2>/dev/null`
		echo $RESULT >&2
	;;

	*) Usage 
	LIST=$2
	 echo $LIST  | xargs >&2
	 exit 1 ;;
esac
