#!/usr/bin/perl
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 
# list_ifcs.cgi
# List active and boot-time interfaces

use lib qw(/usr/lib/naat/backend);
$net_scripts_dir = "/etc/sysconfig/network-scripts";
$network_file = "/etc/sysconfig/network";
$resolv_conf_file = "/etc/resolv.conf";

my $transaction_name = shift @ARGV if @ARGV;

if (! $transaction_name) { 
	$transaction_name = "$$";
	# initialize a backend transaction
	system ("config-wrapper.pl", "$transaction_name", "-i");
}

my $test = `config-wrapper.pl $transaction_name -g Updated`;

if ($test =~ /no/i) { # -- the system was not yet updated --

	#	print "Active interfaces:\n\n";
	@act = &active_interfaces();
	@act = sort iface_sort @act;
	foreach $a (@act) {
		if ($a->{'fullname'} =~ /Eth/i) {
			my $nameIP = "\u$a->{'fullname'}"."IP";
			my $nameKnown = "\u$a->{'fullname'}"."Known";
	  	        my $nameMac = "\u$a->{'fullname'}"."Mac";
			my $IP = $a->{'address'};
			my $nameMask = "\u$a->{'fullname'}"."Mask";
			my $nameZoneName = "\u$a->{'fullname'}"."ZoneName";
			my $Mask = $a->{'netmask'};
			my $Mac = $a->{'ether'};

			#print "nameIP $nameIP IP $IP\n"; 
			#print "nameMask $nameMask Mask $Mask\n"; 
			#print "nameKnown $nameKnown true true\n"; 
			system ("config-wrapper.pl", "$transaction_name", "-s", "$nameIP", "$IP");
			system ("config-wrapper.pl", "$transaction_name", "-s", "$nameMask", "$Mask");
			system ("config-wrapper.pl", "$transaction_name", "-s", "$nameZoneName", "lan");
			system ("config-wrapper.pl", "$transaction_name", "-s", "$nameKnown", "true");
			system ("config-wrapper.pl", "$transaction_name", "-s", "$nameMac", "$Mac");
			system ("config-wrapper.pl", "$transaction_name", "-lainc", "InterfacesList", "1,zone,lan,interface,$a->{'fullname'},broadcast,detect,options,-");
		        };
		};
		
	#print "Boot interfaces:\n\n";
	@boot = &boot_interfaces();
	@boot = sort iface_sort @boot;
	foreach $a (@boot) {
		if ($a->{'fullname'} =~ /Eth/i) {
			my $nameOnBoot = "undefined";
			my $OnBoot = "undefined";
			my $nameBootProto = "undefined";
			my $BootProto ="undefined";

			$nameOnBoot = "\u$a->{'fullname'}"."OnBoot";
			if ($a->{'up'} =~ /yes/i) { 
				$OnBoot = "yes";
			}
			else {
				$OnBoot = "no";
			}; 
			$nameBootProto = "\u$a->{'fullname'}"."BootProto";
			if ($a->{'bootp'} =~ /bootp/i) { 
				$BootProto ="bootp";
			}	
			elsif ($a->{'dhcp'} =~ /dhcp/i) {  
				$BootProto ="dhcp";
			}
			else {
				$BootProto ="static";
			};
			#print "nameOnBoot $nameOnBoot OnBoot $OnBoot \n"; 
			#print "nameBootProto $nameBootProto BootProto $BootProto\n"; 
			system ("config-wrapper.pl", "$transaction_name", "-s", "$nameOnBoot", "$OnBoot");
			system ("config-wrapper.pl", "$transaction_name", "-s", "$nameBootProto", "$BootProto");
		};
	};
	
	};
	
# get the hostname 
@hostname = &hostname();
#print "hostname is $hostname[0]->{'hostname'}\n";
#print "systemname is  $hostname[1]->{'systemname'}\n";
#print "domainname is  $hostname[2]->{'domainname'}\n";
system ("config-wrapper.pl", "$transaction_name", "-s", "SystemName", "$hostname[1]->{'systemname'}");
system ("config-wrapper.pl", "$transaction_name", "-s", "DomainName", "$hostname[2]->{'domainname'}");

# get the nameserver 
@nameserver = &nameserver();
print "the nameserver IP is \n";
system ("config-wrapper.pl", "$transaction_name", "-s", "DNSPrimaryIP", "$nameserver[0]");

system ("config-wrapper.pl", "$transaction_name", "-s", "Updated", "yes");
	
sub iface_sort
{
return $a->{'name'} cmp $b->{'name'} if ($a->{'name'} cmp $b->{'name'});
return $a->{'virtual'} <=> $b->{'virtual'};
}

# active_interfaces()
# Returns a list of currently ifconfig'd interfaces
sub active_interfaces
{
local(@rv, @lines, $l);
open(IFC, "ifconfig -a |");
while(<IFC>) {
        s/\r|\n//g;
        if (/^\S+/) { push(@lines, $_); }
        else { $lines[$#lines] .= $_; }
        }
close(IFC);
foreach $l (@lines) {
        local %ifc;
        $l =~ /^([^:\s]+)/; $ifc{'name'} = $1;
        $l =~ /^(\S+)/; $ifc{'fullname'} = $1;
        if ($l =~ /^(\S+):(\d+)/) { $ifc{'virtual'} = $2; }
        if ($l =~ /inet addr:(\S+)/) { $ifc{'address'} = $1; }
        elsif (!$_[0]) { next; }
        if ($l =~ /Mask:(\S+)/) { $ifc{'netmask'} = $1; }
        if ($l =~ /Bcast:(\S+)/) { $ifc{'broadcast'} = $1; }
        if ($l =~ /HWaddr (\S+)/) { $ifc{'ether'} = $1; }
        if ($l =~ /MTU:(\d+)/) { $ifc{'mtu'} = $1; }
        $ifc{'up'}++ if ($l =~ /\sUP\s/);
        $ifc{'edit'} = ($ifc{'name'} !~ /^ppp/);
        $ifc{'index'} = scalar(@rv);
        push(@rv, \%ifc);
        }
return @rv;
}

# boot_interfaces()
# Returns a list of interfaces brought up at boot time
sub boot_interfaces
{
local(@rv, $f);
opendir(CONF, $net_scripts_dir);
while($f = readdir(CONF)) {
        next if ($f !~ /^ifcfg-[a-z0-9:]+$/);
        local (%conf, $b);
        &read_env_file("$net_scripts_dir/$f", \%conf);
        $b->{'fullname'} = $conf{'DEVICE'};
        if ($b->{'fullname'} =~ /(\S+):(\d+)/) {
                $b->{'name'} = $1;
                $b->{'virtual'} = $2;
                }
        else { $b->{'name'} = $b->{'fullname'}; }
        $b->{'up'} = $conf{'ONBOOT'};
        $b->{'address'} = $conf{'IPADDR'};
        $b->{'netmask'} = $conf{'NETMASK'};
        $b->{'broadcast'} = $conf{'BROADCAST'};
        $b->{'dhcp'} = $conf{'BOOTPROTO'};
        $b->{'bootp'} = $conf{'BOOTPROTO'};
        $b->{'edit'} = ($b->{'name'} !~ /^ppp|irlan/);
        $b->{'index'} = scalar(@rv);
        push(@rv, $b);
        }
closedir(CONF);
return @rv;
}

# boot_interfaces()
# Returns a list of interfaces brought up at boot time
sub hostname 
{
local(@rv, $f);
open(CONF, $network_file);
while(<CONF>) {
        local (%conf, $b);
        &read_env_file("$network_file", \%conf);
        $b->{'hostname'} = $conf{'HOSTNAME'};
	#$b->{'hostname'} =~ m/([^\.])+\.(.*)/;#define $1.$2
        $b->{'hostname'} =~ m/([^\.]+)\.(.*)/;#define $1.$2
	$b->{'systemname'} = $1;
	$b->{'domainname'} = $2;
	$b->{'index'} = scalar(@rv);
        push(@rv, $b);
        }
close(CONF);
return @rv;
}

sub nameserver
{
my $result = "";
open (LIST, "< $resolv_conf_file") or die "Can't open the $resolv_conf_file file for reading";
        while (<LIST>) {
                if (($_ !~ m/^\#/) && ($_ !~ m/^\s/)) { # the first caracter is not a comment sign # or a space
                        chomp($_);
                        my @line = split (/\s+/,$_);
                                if ( $line[0] =~ /nameserver/) {
					$result = $line[1];
					last;
                                };
                };
        };
close (LIST);

return ($result);
}

# read_env_file(file, &array)
sub read_env_file
{
open(FILE, $_[0]) || return 0;
while(<FILE>) {
        s/#.*$//g;
        if (/([A-z0-9_]+)\s*=\s*"(.*)"/ ||
            /([A-z0-9_]+)\s*=\s*'(.*)'/ ||
            /([A-z0-9_]+)\s*=\s*(.*)/) {
                $_[1]->{$1} = $2;
                }
        }
close(FILE);
return 1;
}
