#!/usr/bin/perl -W
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2001 Mandrakesoft
# Author Vincent Saugey <vince@mandrakesoft.com>
#
# $Id: logs.pl,v 1.15 2002/12/04 15:26:16 philippe Exp $
#

# Performs a tail on the specified log file

#$color_red = "#FF0000";
#$color_blue = "#0000FF";
#$color_yellow = "#FFFF00";
$MODULES="modules";
$HREFDIR="/genfiles/$MODULES";
$WEBDIR="/var/www-naat/html/$HREFDIR";



# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
# WARNING: this script ALWAYS takes a transaction as a first argument
my ($output, $olddate) =("","");

my $transaction_name; 
if (@ARGV) {
   $transaction_name = shift @ARGV ; 
}
else {
    print STDERR "Usage : log.pl <transaction_name> [type]\n\nWhere type egals to : syslog, messages, packets, auth, errors\nBy default type = messages\n";
    exit 1;
}

my $log_type = shift @ARGV if (@ARGV); 

my $comma=",";
if ($log_type) {
for ($log_type) {
    /packets/ and $output = fwlog(), goto END;
    /messages/ and @input = `tail --lines=40 /var/log/messages`, last;
    /auth/ and @input = `tail --lines=40 /var/log/auth.log`, last;
    /squid/ and $output = squidlog(), goto END;
    /prelude/ and $output = preludelog(), goto END;
    /snort/ and $output = snortlog(), goto END;
    /dhcp/ and $output = dhcplog(), goto END;
# /errors/ && @input = `tail --lines=40 /var/log/boot.log` && last;
    @input = `tail --lines=40 /var/log/syslog`;
}
}
    
my ($date, $time);

chomp @input;

$comma=",";
foreach $line (@input)
{
	next unless ($line =~ /^(\S+\s+\d+)\s+(\d+:\d+:\d+)\s+\S+\s+(\w+)(\[.*\])*:\s+(.+)$/);
	($date, $time, $process, $line) = ($1, $2, $3, $5);
	$date=encrypt($date);
	$line=encrypt($line);

	$output .= "\u$date (";
	$output .= "time=$time process=$process message=$line)$comma";

	$olddate = $date;
	$comma=",";
}

chomp $output;

if ($output =~ /\S+/) { 
	$output =~ s/,$//;
} else {
    $output = encrypt ("Click on Refresh.\n\nIf nothing is displayed, then check out your configuration.");
}

END:

print "$output\n" if ($output);

#this sub replace many characters by their %XX counterparts
sub encrypt
{
  my $result = shift;

if ($result) {
  $result =~ s/%/%25/g; # this one should be the first !!!
  $result =~ s/\t/%09/g;
  $result =~ s/\n/%13/g;
  $result =~ s/\r/%10/g;
  $result =~ s/ /%20/g;
  $result =~ s/!/%21/g;
  $result =~ s/\"/%22/g;
  $result =~ s/\#/%23/g;
  $result =~ s/$/%24/g;
  $result =~ s/&/%26/g;
  $result =~ s/\'/%27/g;
  $result =~ s/\(/%28/g;
  $result =~ s/\)/%29/g;
  $result =~ s/\*/%2A/g;
  $result =~ s/\+/%2B/g;
  $result =~ s/,/%2C/g;
  $result =~ s/-/%2D/g;
  $result =~ s/\./%2E/g;
  $result =~ s!/!%2F!g;
};
  return $result;

}

sub display_link  {
				my ($href,$label)=@_;
				my $out.="<A onClick='window.open(\"$href\",\"logs\",\"toolbar=yes,menubar=no,scrollbars=yes,width=800,height=480,resizable=yes\"); return false' href=\"$href\">$label</A>";
				return $out;
}

sub squidlog
{
				system ("config-test.pl $transaction_name SquidServer off");  

				if (($?>>8) == 1) {
								my $label = "The Squid Proxy Server was not activated yet";
								my $link = encrypt("empty");
								my $value = encrypt($label);
								$OUT .= "$link (label=$value)";
				} else {
								if ( -d "$WEBDIR/squid-reports/daily" ) {
												my $label = "Daily Reports";
												my $href = "$HREFDIR/squid-reports/daily/index.html";
												my $link=encrypt(display_link("$href","<img title=\"View\" border=\"0\" src=\"images/icn-magnify.png\" alt=\"$label\"/>"));
												my $value=encrypt($label);
												$OUT .= "$link (label=$value)$comma";
								}
								if (-d "$WEBDIR/squid-reports/weekly") {
												my $label = "Weekly Reports";
												my $href = "$HREFDIR/squid-reports/weekly/index.html";
												my $link=encrypt(display_link("$href","<img title=\"View\" border=\"0\" src=\"images/icn-magnify.png\" alt=\"$label\"/>"));
												my $value=encrypt($label);
												$OUT .= "$link (label=$value)$comma";
								}
								if (-d "$WEBDIR/squid-reports/monthly") {
												my $label = "Monthly Reports";
												my $href = "$HREFDIR/squid-reports/monthly/index.html";
												my $link=encrypt(display_link("$href","<img title=\"View\" border=\"0\" src=\"images/icn-magnify.png\" alt=\"$label\"/>"));
												my $value=encrypt($label);
												$OUT .= "$link (label=$value)$comma";
								}
}
return $OUT;
}


sub preludelog
{
				system ("config-test.pl $transaction_name PreludeState on");
				if (($?>>8) == 1) {
								if (-d "$WEBDIR/prelude/latest/") {
												my $label = "Prelude Reports";
												my $href = "$HREFDIR/prelude/latest/index.html";
												my $link=encrypt(display_link("$href","<img title=\"View\" border=\"0\" src=\"images/icn-magnify.png\" alt=\"$label\"/>"));
												my $value=encrypt($label);
												$OUT .= "$link (label=$value)$comma";
								} else {
												my $label = "No log available !";
												my $link = encrypt("empty");
												my $value = encrypt($label);
												$OUT .= "$link (label=$value)";
								}
				} else {
								my $label = "Prelude IDS was not activated yet";
								my $link = encrypt("empty");
								my $value = encrypt($label);
								$OUT .= "$link (label=$value)";
				}
				return $OUT;
}

sub snortlog
{
				system ("config-test.pl $transaction_name SnortState on");
				if (($?>>8) == 1) {
								system ("config-wrapper.pl $transaction_name --get SnortLogs");
								if (-d "$WEBDIR/snort") {
												my $label = "Snort Reports";
												my $href = "$HREFDIR/snort/index.html";
												my $link=encrypt(display_link("$href","<img title=\"View\" border=\"0\" src=\"images/icn-magnify.png\" alt=\"$label\"/>"));
												my $value=encrypt($label);
												$OUT .= "$link (label=$value)$comma";
								} else {
												my $label = "No log available !";
												my $link = encrypt("empty");
												my $value = encrypt($label);
												$OUT .= "$link (label=$value)";
								}
				} else {
								my $label = "Snort IDS was not activated yet";
								my $link = encrypt("empty");
								my $value = encrypt($label);
								$OUT .= "$link (label=$value)";
				}
				return $OUT;
}

sub dhcplog
{
				system ("config-test.pl $transaction_name DHCPServer on"); 
				if (($?>>8) == 1) {
								if (-d "/var/www-naat/cgi-bin") {
												my $label = "DHCP Reports";
												my $href = "/cgi-bin/dhcpstatus.cgi";
												my $link=encrypt(display_link("$href","<img title=\"View\" border=\"0\" src=\"images/icn-magnify.png\" alt=\"$label\"/>"));
												my $value=encrypt($label);
												$OUT .= "$link (label=$value)";
								}	else {
												my $label = "No log available !";
												my $link = encrypt("empty");
												my $value = encrypt($label);
												$OUT .= "$link (label=$value)";
								}
				} else {
								my $label = "The DHCP server was not activated yet";
								my $link = encrypt("empty");
								my $value = encrypt($label);
								$OUT .= "$link (label=$value)";
				}
				return $OUT;
}

sub fwlog
{
				$OUT.=`config-wrapper.pl $transaction_name --get FirewallLogs`; 
				if (! -d "$WEBDIR/fwlogwatch") {
								my $label = "No Firewall log available !";
								my $link = encrypt("empty");
								my $value = encrypt($label);
								$OUT .= "$link (label=$value)";
				}
				return $OUT;
}

