#!/usr/bin/perl
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
#
# $Id: providers.pl,v 1.2 2002/12/04 15:26:16 philippe Exp $
#

# Add the current provider infos in the appropriate list (ADSLProviders, PPPProviders, ISDNProviders)

# !!!!!!!!!!!!!!
# Since it performs a commit, must be triggered only because of an event, and not be used by 
# a proxy variable
# !!!!!!!!!!!!!!


$transaction_name = "$$";
# initialize a backend transaction
system ("config-wrapper.pl", "$transaction_name", "-i");

# First get the current InternetAccess
my $InternetAccessType = `config-wrapper.pl $transaction_name -g InternetAccessType`;


# Act accordingly
if ( $InternetAccessType =~ /ADSL/i ) {
    # Get appropriate infos
    my @infos = map { chomp; s/\s*(\S+)\s*/$1/; $_; } `config-wrapper.pl $transaction_name -g ADSLProviderDomain -g ADSLLogin -g ADSLPassword -g ADSLProviderDNS1 -g ADSLProviderDNS2`;
    
    # Store infos in ADSLProviders list
    system ("config-wrapper.pl", "$transaction_name", "-la","ADSLProviders",@infos[0],"Login",@infos[1],"Password",@infos[2],"DNS1",@infos[3],"DNS2",@infos[4]);
}

elsif ( $InternetAccessType =~ /ISDN/i ) {
    # Get appropriate infos
    my @infos = map { chomp; s/\s*(\S+)\s*/$1/; $_; } `config-wrapper.pl $transaction_name -g ISDNProviderDomain -g ISDNLogin -g ISDNPassword -g ISDNProviderDNS1 -g ISDNProviderDNS2 -g ISDNProviderPhone -g ISDNPersonalPhone`;
    
    # Store infos in ISDNProviders list
    system ("config-wrapper.pl", "$transaction_name", "-la","ISDNProviders",@infos[0],"Login",@infos[1],"Password",@infos[2],"DNS1",@infos[3],"DNS2",@infos[4],"ProviderPhone",@infos[5],"PersonalPhone",@infos[6]);
}

elsif ( $InternetAccessType =~ /PPP/i ) {
    # Get appropriate infos
    my @infos = map { chomp; s/\s*(\S+)\s*/$1/; $_; } `config-wrapper.pl $transaction_name -g PPPProviderDomain -g PPPLogin -g PPPPassword -g PPPProviderDNS1 -g PPPProviderDNS2 -g PPPProviderPhone -g PPPAuth`;
    
    # Store infos in PPPProviders list
    system ("config-wrapper.pl", "$transaction_name", "-la","PPPProviders",@infos[0],"Login",@infos[1],"Password",@infos[2],"DNS1",@infos[3],"DNS2",@infos[4],"ProviderPhone",@infos[5],"Auth",@infos[6]);

}

elsif ( $InternetAccessType =~ /LAN/i ) {
    # not supported yet
}

# commit
system ("config-wrapper.pl", "$transaction_name", "-c");
