#!/usr/bin/perl
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
#
# $Id: rpm-install.pl,v 1.4 2002/12/04 15:26:16 philippe Exp $
#
# Modified by: francois Pons <fpons@mandrakesoft.com>
#

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
# my $transaction_name = shift @ARGV ; 

my $transaction_name = shift @ARGV if @ARGV;

# if $test = 1, the package list is taken on the command-line
# if $test = 0, the package list is taken from the proxy variable config file
my $test = 0;

# First part, get the config variables...
my ($CurrentMirror, $PackagesList);

if ($test)
{
  $CurrentMirror = $ARGV[0];
  $PackagesList = $ARGV[1];
} else
{
  if (! $transaction_name ) {
	$transaction_name = "$$";
	# initialize a backend transaction
	system ("config-wrapper.pl $transaction_name -i");
  }

  # Get the CurrentMirror value
  $CurrentMirror = `config-wrapper.pl $transaction_name -g CurrentMirror`;
  chomp $CurrentMirror;
  # Get the PackagesList
  $PackagesList = `config-wrapper.pl $transaction_name -g PackagesList`;

}



use urpm;
$urpm = new urpm;
$urpm->read_config;
($medium) = grep { $_->{name} eq "Update" } @{$urpm->{media}};
$medium or die "unable to find Update medium\n";
$urpm->parse_synthesis($medium);

my %packages;
chomp $PackagesList;
$urpm->search_packages(\%packages, [ split ",", $PackagesList ]);
$urpm->filter_packages_to_upgrade(\%packages,  sub {
   my ($urpm, $from_id, @choices_id) = @_;
   $choices_id[0];
});

my ($local_sources, $list, $local_to_removes) = $urpm->get_source_packages(\%packages);
unless ($local_sources || $list) {
       die "unable to get source packages, aborting\n";
}
# clean cache (necessary to avoid /var/cache/urpmi explosion).
foreach (@$local_to_removes) {
       unlink $_;
}
my %sources = $urpm->download_source_packages($local_sources, $list, 'force_local', undef);
my @rpms_upgrade = grep { $_ !~ /\.src.\.rpm/ } values %sources;

my $status = system "/bin/rpm", "-Uvh", @rpms_upgrade;

if (!$status) {
    # remove packages
    system "rm", "-f", @rpms_upgrade;
				    system "config-wrapper.pl", "$transaction_name", "-s","PackagesList";
}

  if ( $transaction_name eq "$$" ) {
      # cleanup the transaction
      system ("config-wrapper.pl $transaction_name -a");
  }
exit ($status);
