#!/usr/bin/perl -w
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2000,2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
#
# $Id: services.pl,v 1.6 2002/12/04 15:26:16 philippe Exp $
#

use strict;

# Usage: services.pl [trans_name] action [service_name]
# action : list | status | start | stop

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if (scalar(@ARGV)==3 || 
				       (scalar(@ARGV)==2 && $ARGV[1] =~ /list/i) );

exit (1) unless @ARGV;

if ( $ARGV[0] =~ /list/i ) {
    # parse /etc/init.d
    (my $runlevel = `/sbin/runlevel`) =~ s/. (\d)/$1/  ;
    chomp $runlevel;
    my @runlevel_services = `ls /etc/rc${runlevel}\.d/S[0-9]* 2>/dev/null`; 
    my $info = "";
    foreach ( @runlevel_services ) {
	s/^.*S[0-9]*//;  # get the service name only
	chomp;            # no trailing newline

	next if ($_ =~ /local/i);

	# get the service status
	my $status = `LANG=C LANGUAGE=C LC_CTYPE=C LC_NUMERIC=C LC_TIME=C LC_COLLATE=C LC_MONETARY=C LC_MESSAGES=C LC_PAPER=C LC_NAME=C LC_ADDRESS=C LC_TELEPHONE=C LC_MEASUREMENT=C LC_IDENTIFICATION=C LC_ALL=C sudo /sbin/service $_ status`;
	if ($status =~ /running/i) {
	    $status = "Running";
	} elsif ($status =~ /stopped/i) {
	    $status = "Stopped";
	} else {
	    $status = "Details--->";
	}

	$info .= "$_ (Status=$status),";
    }
    $info =~ s/,$//;
    print "$info\n";

} elsif ( $ARGV[0] =~ /add/i && $ARGV[1] ) {
    my $service = "\L$ARGV[1]";
    my $output = system ("sudo", "/sbin/chkconfig", "--add", "$service");
    $output = encrypt ($output);
    print $output."\n";

} elsif ( $ARGV[0] =~ /remove/i && $ARGV[1] ) {
    my $service = "\L$ARGV[1]";
    my $output = system ("sudo", "/sbin/chkconfig", "--del", "$service");
    $output = encrypt ($output);
    print $output."\n";

} elsif ( $ARGV[1] ) {
    my $service = "\L$ARGV[1]";
    	my $output = system ("sudo", "/sbin/service", "$service", "$ARGV[0]");
    	$output = encrypt ($output);
    	print $output."\n";
} else {
    print STDERR "Error with parameters : ", join (" ", @ARGV), " in script services.pl \n";
}


#this sub replace many characters by their %XX counterparts
sub encrypt
{
  my $result = shift;
  $result =~ s/%/%25/g; # this one should be the first !!!
  $result =~ s/\t/%09/g;
  $result =~ s/\n/%13/g;
  $result =~ s/\r/%10/g;
  $result =~ s/\n/%13/g;
  $result =~ s/ /%20/g;
  $result =~ s/!/%21/g;
  $result =~ s/\"/%22/g;
  $result =~ s/\#/%23/g;
  $result =~ s/$/%24/g;
  $result =~ s/&/%26/g;
  $result =~ s/\'/%27/g;
  $result =~ s/\(/%28/g;
  $result =~ s/\)/%29/g;
  $result =~ s/\*/%2A/g;
  $result =~ s/\+/%2B/g;
  $result =~ s/,/%2C/g;
  $result =~ s/-/%2D/g;
  $result =~ s/\./%2E/g;
  $result =~ s!/!%2F!g;

  return $result;
}

