#!/usr/bin/perl

# Copyright (C) 2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
#
# $Id: set-provider.pl,v 1.3 2003/05/15 11:27:47 florin Exp $
#

# Set the infos corresponding to the chosen provider
# in the current transaction


# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if @ARGV;
exit if ! $transaction_name;

my $provider_name = shift @ARGV if @ARGV;
exit if ! $provider_name;

# First get the current InternetAccess
my $InternetAccessType = `config-wrapper.pl $transaction_name -g InternetAccessType`;

# Act accordingly
if ( $InternetAccessType =~ /ADSL/i ) {
  my $DNS1 = `config-wrapper.pl $transaction_name -lg ADSLProviders ${provider_name} DNS1`;
  chomp $DNS1;

  my $DNS2 = `config-wrapper.pl $transaction_name -lg ADSLProviders ${provider_name} DNS2`;
  chomp $DNS2;

  my $Login = `config-wrapper.pl $transaction_name -lg ADSLProviders ${provider_name} Login`;
  chomp $Login;

  my $Password = `config-wrapper.pl $transaction_name -lg ADSLProviders ${provider_name} Password`;
  chomp $Password;

    # ADSLLogin ADSLPassword ADSLProviderDomain ADSLProviderDNS1 ADSLProviderDNS2
    system ("config-wrapper.pl","$transaction_name","-s","ADSLProviderDomain",$provider_name,
	    "-s","ADSLLogin",${Login},
	    "-s","ADSLPassword",${Password},
	    "-s","ADSLConfirmPassword",${Password},
	    "-s","ADSLProviderDNS1",${DNS1},
	    "-s","ADSLProviderDNS2",${DNS2});
}

elsif ( $InternetAccessType =~ /ISDN/i ) {
    # Get appropriate infos
  my $ProviderPhone = `config-wrapper.pl $transaction_name -lg ISDNProviders ${provider_name} ProviderPhone`;
  chomp $ProviderPhone;

  my $PersonalPhone = `config-wrapper.pl $transaction_name -lg ISDNProviders ${provider_name} PersonalPhone`;
  chomp $ProviderPhone;

  my $DNS1 = `config-wrapper.pl $transaction_name -lg ISDNProviders ${provider_name} DNS1`;
  chomp $DNS1;

  my $DNS2 = `config-wrapper.pl $transaction_name -lg ISDNProviders ${provider_name} DNS2`;
  chomp $DNS2;

  my $Login = `config-wrapper.pl $transaction_name -lg ISDNProviders ${provider_name} Login`;
  chomp $Login;

  my $Password = `config-wrapper.pl $transaction_name -lg ISDNProviders ${provider_name} Password`;
  chomp $Password;

    system ("config-wrapper.pl","$transaction_name","-s","ISDNProviderDomain",$provider_name,
	    "-s","ISDNLogin",$infos{"Login"},
	    "-s","ISDNPassword",$infos{"Password"},
	    "-s","ISDNProviderDNS1",$infos{"DNS1"},
	    "-s","ISDNProviderDNS2",$infos{"DNS2"},
	    "-s","ISDNProviderPhone",$infos{"ProviderPhone"},
	    "-s","ISDNPersonalPhone",$infos{"PersonalPhone"});

}

elsif ( $InternetAccessType =~ /PPP/i ) {
	
  my $ProviderPhone = `config-wrapper.pl $transaction_name -lg PPPProviders ${provider_name} ProviderPhone`;
  chomp $ProviderPhone;

  my $DNS1 = `config-wrapper.pl $transaction_name -lg PPPProviders ${provider_name} DNS1`;
  chomp $DNS1;

  my $DNS2 = `config-wrapper.pl $transaction_name -lg PPPProviders ${provider_name} DNS2`;
  chomp $DNS2;

  my $Login = `config-wrapper.pl $transaction_name -lg PPPProviders ${provider_name} Login`;
  chomp $Login;

  my $Password = `config-wrapper.pl $transaction_name -lg PPPProviders ${provider_name} Password`;
  chomp $Password;

  my $Auth = `config-wrapper.pl $transaction_name -lg PPPProviders ${provider_name} Auth`;
  chomp $Auth;

  system("config-wrapper.pl","$transaction_name",
  	 "-s", "PPPProviderPhone", ${ProviderPhone},
	 "-s", "PPPProviderDomain", $provider_name,
	 "-s", "PPPProviderDNS1", ${DNS1},
	 "-s", "PPPProviderDNS2", ${DNS2},
	 "-s", "PPPLogin", ${Login},
	 "-s", "PPPPassword", ${Password},
	 "-s", "PPPConfirmPassword", ${Password},
	 "-s", "PPPAuth", ${Auth});

}
elsif ( $InternetAccessType =~ /LAN/i ) {
    # not supported yet
}

