#!/usr/bin/perl -w
#/*
# Copyright (C) 2002 MandrakeSoft SA
# 
# This program may be distributed and/or
# modified under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Licensees holding valid MandrakeSecurity MNF Commercial License may use this
# file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
# provided with the Software.
# 
# See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
#*/ 

# Copyright (C) 2001 Mandrakesoft
# Author Florin Grad <florin@mandrakesoft.com>
# 
# $Id: squidGuard_manage.pl,v 1.2 2002/12/04 15:26:16 philippe Exp $
#

use strict;
use lib qw(/usr/lib/naat);
use backend::util;

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if ( @ARGV && $ARGV[1] !~ /^-/ );

my $Usage =<<"End_of_Usage;";

Usage:	squidGuard_manage.pl [trans_name] db_file < -l | -a entry | -d entry | -e(l|d|a) entry>
	squidGuard_manage.pl [trans_name] db_file < --list | --add entry | --delete entry | --expr(list|delete|add) entry>

--list|-l	Displays the list of entries (IPs or Urls or Domains)

--add|-a	Add an entry (IPs or Urls or Domains) at the end of the list
		EXAMPLE: squidGuard_manage.pl /usr/share/squidGuard-1.1.4/db/advertising/urls -a adserver.jokes.com/image.ng/

--delete|-d	Deletes the coresponding entry from db config file (IP or Urls or Domains)
		EXAMPLE: squidGuard_manage.pl /usr/share/squidGuard-1.1.4/db/bannedsource/ips -d 192.168.1.215
--expression|-expr 

End_of_Usage;

# arg0 : list | add | delete

# Check if there are at least 2 arguments given
if ( scalar (@ARGV) le 1 ) {
    print STDERR $Usage;
    exit(3);
}

if ( $ARGV[1] eq "--list" || $ARGV[1] eq "-l") {
	backend::util::print_list_squidGuard_db_file($ARGV[0]);
} elsif ( $ARGV[1] eq "--add" || $ARGV[1] eq "-a") {
	backend::util::add_to_list_squidGuard_db_file ($ARGV[0], $ARGV[2]);
} elsif ( $ARGV[1] eq "--delete" || $ARGV[1] eq "-d") {
	backend::util::delete_squidGuard_db_file_entry ($ARGV[0], $ARGV[2]);
} elsif ( $ARGV[1] eq "--exprlist" || $ARGV[1] eq "-el") {
	backend::util::print_list_squidGuard_expr_file ($ARGV[0]);
} elsif ( $ARGV[1] eq "--expradd" || $ARGV[1] eq "-ea") {
    backend::util::add_to_list_squidGuard_expr_file ($ARGV[0], $ARGV[2]);
} elsif ( $ARGV[1] eq "--exprdelete" || $ARGV[1] eq "-ed") {
    backend::util::delete_squidGuard_expr_file_entry ($ARGV[0], $ARGV[2]);
} else {
print STDERR $Usage;
};

